<?php
require_once ('index_top.php');
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
   <head>
      <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
      <title>Stopniowa weryfikacja formularza - AJAX, PHP i MySQL</title>
      <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
      <link href="validate.css" rel="stylesheet" type="text/css" />   
   </head>
   
   <body onload="setFocus();">
   <script type="text/javascript" src="json2.js"></script>
   <script type="text/javascript" src="xhr.js"></script>
   <script type="text/javascript" src="validate.js"></script>
   <fieldset>
      <legend class="txtFormLegend">Formularz rejestracji nowego użytkownika</legend>
      <br />
      <form name="frmRegistration" method="post" action="validate.php">
         <input type="hidden" name="validationType" value="php"/>
            <!-- Nazwa użytkownika -->
            <label for="txtUsername">Nazwa użytkownika:</label>
            <input id="txtUsername" name="txtUsername" type="text" 
                      onblur="validate(this.value, this.id)" 
 
                      value="<?php echo $_SESSION['values']['txtUsername'] ?>" />
            <span id="txtUsernameFailed"
                     class="<?php echo $_SESSION['errors']['txtUsername'] ?>">
               Zmień nazwę, jeśli podana jest zajęta, lub wypełnij pole "Nazwa użytkownika".
            </span>
            <br />
   
            <!-- Imię i nazwisko -->
            <label for="txtName">Twoje nazwisko:</label>
            <input id="txtName" name="txtName" type="text" 
                      onblur="validate(this.value, this.id)" 
                      value="<?php echo $_SESSION['values']['txtName'] ?>" />
            <span id="txtNameFailed"
                     class="<?php echo $_SESSION['errors']['txtName'] ?>">
               Podaj swoje imię i nazwisko. 
            </span>
            <br />
               
            <!-- Płeć -->
            <label for="selGender">Płeć:</label>
            <select name="selGender" id="selGender" 
                        onblur="validate(this.value, this.id)">
               <?php buildOptions($genderOptions, 
                                           $_SESSION['values']['selGender']); ?>
            </select>
            <span id="selGenderFailed"
                     class="<?php echo $_SESSION['errors']['selGender'] ?>">
               Jakiej jesteś płci? 
            </span>
            <br />
               
            <!-- Data urodzenia -->
            <label for="selBthMonth">Data urodzenia:</label>
            
            <!-- Dzień -->
            <input type="text" name="txtBthDay" id="txtBthDay" maxlength="2" 
                      size="2" 
                      onblur="validate(this.value, this.id)" 
                      value="<?php echo $_SESSION['values']['txtBthDay'] ?>" />
            &nbsp;-&nbsp; 
            
            <!-- Miesiąc -->
            <select name="selBthMonth" id="selBthMonth" 
                        onblur="validate(this.value, this.id)">
               <?php buildOptions($monthOptions, 
                                           $_SESSION['values']['selBthMonth']); ?>
            </select>          
            &nbsp;-&nbsp;
            
            <!-- Rok -->
            <input type="text" name="txtBthYear" id="txtBthYear" maxlength="4" 
                      size="2" onblur="validate(document.getElementById('selBthMonth').options[document.getElementById('selBthMonth').selectedIndex].value + '#' + document.getElementById('txtBthDay').value + '#' + this.value, this.id)" 
                      value="<?php echo $_SESSION['values']['txtBthYear'] ?>" />
            
            <!-- Sprawdzenie wartości dzień, miesiąć i rok -->
            <span id="txtBthDayFailed"
                     class="<?php echo $_SESSION['errors']['txtBthDay'] ?>">
               Podaj dzień urodzenia. 
            </span>
            <span id="selBthMonthFailed"
                     class="<?php echo $_SESSION['errors']['selBthMonth'] ?>">
               Podaj miesiąc urodzenia. 
            </span>
            <span id="txtBthYearFailed"
                     class="<?php echo $_SESSION['errors']['txtBthYear'] ?>">
               Podaj poprawny rok. 
            </span>
            <br />
            
            <!-- Email -->
            <label for="txtEmail">E-mail:</label>
            <input id="txtEmail" name="txtEmail" type="text" 
                      onblur="validate(this.value, this.id)" 
                      value="<?php echo $_SESSION['values']['txtEmail'] ?>" />
            <span id="txtEmailFailed"
                     class="<?php echo $_SESSION['errors']['txtEmail'] ?>">
               Niepoprawny adres e-mail.
            </span>
            <br />
               
            <!-- Numer telefonu -->
            <label for="txtPhone">Numer telefonu:</label>
            <input id="txtPhone" name="txtPhone" type="text" 
                      onblur="validate(this.value, this.id)" 
                      value="<?php echo $_SESSION['values']['txtPhone'] ?>" />
            <span id="txtPhoneFailed"
                     class="<?php echo $_SESSION['errors']['txtPhone'] ?>">
               Podaj numer telefonu zapisany w formacie (xxx-xx-xx). 
            </span>
            <br />
               
            <!-- Potwierdzenie znajomości warunków użytkowania -->
            <input type="checkbox" id="chkReadTerms" name="chkReadTerms" 
                      class="left" 
                      onblur="validate(this.checked, this.id)" 
                      <?php if ($_SESSION['values']['chkReadTerms'] == 'on') 
                               echo 'checked="checked"' ?> /> 
            Przeczytałem warunki użytkowania.
            <span id="chkReadTermsFailed"
                     class="<?php echo $_SESSION['errors']['chkReadTerms'] ?>">
               Upewnij się, że zapoznałeś się z warunkami użytkowania. 
            </span>
            
            <!-- Koniec formularza -->
            <hr />
            <span class="txtSmall">Uwaga: Wszystkie pola są obowiązkowe.</span>
            <br /><br />
            <input type="submit" name="submitbutton" value="Zarejestruj" 
                      class="left button" />
         </form>
      </fieldset>
   
   </body>
</html>
